con
  channels = 8 '8 is the recommended max, any more starts to stretch the period past 20ms

var

  long cog
  long servo_stack[20]
  long downtime
  
  long pulse_width[channels]
  
  byte servo_pin[channels]

pub start :okay | count

  repeat count from 0 to channels - 1
    servo_pin[count] := $ff

  okay := cog := cognew(servo_main, @servo_stack) + 1
  
pub stop

  if cog
    cogstop(cog~ - 1)

pub set(channel, pin, width) | count, uptime

  servo_pin[channel] := pin
  pulse_width[channel] := (width - 20) * (clkfreq / 1_000_000)
  uptime := 0
  repeat count from 0 to channels - 1
    if servo_pin[count] == $ff
      next
    uptime += pulse_width[count]
  downtime := (20000 * (clkfreq / 1_000_000) - uptime) #> (2000 * (clkfreq / 1_000_000))
       

pri servo_main | count

repeat
  repeat count from 0 to channels - 1
    if servo_pin[count] == $ff
      next
    dira[servo_pin[count]] := 1
    outa[servo_pin[count]] := 1
    waitcnt(pulse_width[count] + cnt)
    outa[servo_pin[count]] := 0
  waitcnt(downtime + cnt)